def swap(lst, i, j):
    temp = lst[i]
    lst[i] = lst[j]
    lst[j] = temp

def selection_sort(alist):

    # for each position in the list...
    for pos in range(0, len(alist)):

        # find location of minimum element
        pos_of_min = pos
        for location in range(pos, len(alist)):
            if alist[location] < alist[pos_of_min]:
                pos_of_min = location

        # move that element into position pos
        swap(alist,pos,pos_of_min)


def insertion_sort(alist):
    # for each element in the list...
    for pos in range(0, len(alist)):
        # swap that element down to correct (relative) position
        curr_pos = pos
        while(curr_pos > 0 and alist[curr_pos] < alist[curr_pos - 1]): # while wrong
              swap(alist, curr_pos, curr_pos - 1)
              curr_pos -= 1


def merge(lst, start, end):
    middle = start+int((end-start)/2)
    olist = lst[:middle]
    pos = start
    i = start
    j = middle
    while i < middle:
        if j == end or olist[i] < lst[j]:
            lst[pos] = olist[i]
            i += 1
        else:
            lst[pos] = lst[j]
            j += 1
        pos += 1

def merge_sort_helper(lst, start, end):
    # Base Case
    if end-start < 2:
        return

    # Recursive Case
    middle = start + int((end-start) / 2)
    print(start, middle, end)
    merge_sort_helper(lst, start, middle)
    merge_sort_helper(lst, middle, end)
    merge(lst, start, end)

def merge_sort(lst):
    merge_sort_helper(lst,0, len(lst))

def main():
    alist = [10, 46, -10, -100, 0, 47, 4, 23, -3]
    print(alist)
    selection_sort(alist)
    print(alist)

    alist = [10, 46, -10, -100, 0, 47, 4, 23, -3]
    print(alist)
    insertion_sort(alist)
    print(alist)

    alist = [10, 46, -10, -100, 0, 47, 4, 23, -3]
    print(alist)
    merge_sort(alist)
    print(alist)

if __name__=="__main__":
    main()
